c ---------------------------------------------------------------------
      subroutine gridgen(nx,ny,nz,a,x,itmax,tol,omega)
c ---------------------------------------------------------------------
      implicit real*8 (a-h,o-z)
      real*8 x(0:nx,0:ny,0:nz,3)
      real*8 a(7,0:nx,0:ny,0:nz)
c
      call initial(nx,ny,nz,x)
      do 1000 id = 1,3
         call matrix (nx,ny,nz,a,id)
         call sor123 (nx,ny,nz,a,x(0,0,0,id),id,itmax,tol,omega)
 1000 continue
c
 9999 return
      end

c ---------------------------------------------------------------------
      subroutine initial(nx,ny,nz,x)
c ---------------------------------------------------------------------
      implicit real*8 (a-h,o-z)
      real*8 x(0:nx,0:ny,0:nz,3)
c
      hx = 1.0d0/dble(nx)
      hy = 1.0d0/dble(ny)
      hz = 1.0d0/dble(nz)
c
      do 1000 i=0,nx
         temp = dble(i)*hx
      do 1000 k=0,nz
      do 1000 j=0,ny
         x(i,j,k,1) = temp
 1000 continue
c
      do 2000 j=0,ny
         temp = dble(j)*hx
      do 2000 k=0,nz
      do 2000 i=0,nx
         x(i,j,k,2) = temp
 2000 continue
c
      do 3000 k=0,nz
         temp = dble(k)*hx
      do 3000 j=0,ny
      do 3000 i=0,nx
         x(i,j,k,3) = temp
 3000 continue
c
 9999 return
      end

c ---------------------------------------------------------------------
      subroutine matrix (nx,ny,nz,a,id)
c ---------------------------------------------------------------------
      implicit real*8 (a-h,o-z)
      real*8 a(7,0:nx,0:ny,0:nz),tm(6)
c
      one = 1.0d0
      half= 0.5d0
      hx  = one/dble(nx)
      hy  = one/dble(ny)
      hz  = one/dble(nz)
c
      nxm1 = nx-1
      nym1 = ny-1
      nzm1 = nz-1
c
      tm(1) = one
      tm(2) = one
      tm(3) = one
      tm(4) = one
      tm(5) = one
      tm(6) = one
c
      if(id.eq.1) then
        n1=1
        n2=2
      elseif(id.eq.2) then
        n1=3
        n2=4
      else
        n1=5
        n2=6
      endif
c
      do 1000 k=0,nz
      pz = dble(k)*hz
      do 1000 j=0,ny
      py = dble(j)*hy
      do 1000 i=0,nx
      px = dble(i)*hx
         vaa= aa(px,py,pz)
         if(id.eq.1) then
            tm(n1) = half*(vaa+aa(px-hx,py,pz))
            tm(n2) = half*(vaa+aa(px+hx,py,pz))
         elseif(id.eq.2) then
            tm(n1) = half*(vaa+aa(px,py-hy,pz))
            tm(n2) = half*(vaa+aa(px,py+hy,pz))
         else
            tm(n1) = half*(vaa+aa(px,py,pz-hz))
            tm(n2) = half*(vaa+aa(px,py,pz+hz))
         endif
         tm7 = 4.0d0+tm(n1)+tm(n2)
         a(1,i,j,k) = -tm(1)
         a(2,i,j,k) = -tm(2)
         a(3,i,j,k) = -tm(3)
         a(4,i,j,k) = -tm(4)
         a(5,i,j,k) = -tm(5)
         a(6,i,j,k) = -tm(6)
         a(7,i,j,k) = tm7
 1000 continue
c
      if(id.eq.1) goto 50
c
      i = 0
      do 2100 k=0,nz
      do 2100 j=0,ny
        a(2,i,j,k) = a(2,i,j,k)+a(1,i,j,k)
        a(1,i,j,k) = 0.0d0
 2100 continue
      i = nx
      do 2200 k=0,nz
      do 2200 j=0,ny
        a(1,i,j,k) = a(1,i,j,k)+a(2,i,j,k)
        a(2,i,j,k) = 0.0d0
 2200 continue
c
 50   if(id.eq.2) goto 55
c
      j = 0
      do 2300 k=0,nz
      do 2300 i=0,nx
        a(4,i,j,k) = a(4,i,j,k)+a(3,i,j,k)
        a(3,i,j,k) = 0.0d0
 2300 continue
      j = ny
      do 2400 k=0,nz
      do 2400 i=0,nx
        a(3,i,j,k) = a(3,i,j,k)+a(4,i,j,k)
        a(4,i,j,k) = 0.0d0
 2400 continue
c
 55   if(id.eq.3) goto 9999
c
      k = 0
      do 2500 j=0,ny
      do 2500 i=0,nx
        a(6,i,j,k) = a(6,i,j,k)+a(5,i,j,k)
        a(5,i,j,k) = 0.0d0
 2500 continue
      k = nz
      do 2600 j=0,ny
      do 2600 i=0,nx
        a(5,i,j,k) = a(5,i,j,k)+a(6,i,j,k)
        a(6,i,j,k) = 0.0d0
 2600 continue
c
 9999 return
      end

c ---------------------------------------------------------------------
      real*8 function aa(x,y,z)
c ---------------------------------------------------------------------
      implicit real*8 (a-h,o-z)
      common / ndata1 / nx,ny,nz
      common / rdata1 / x0(3)
      common / rdata2 / epsilon,weight
c
      ep2= 2.0d0*epsilon
      hx6= 6.0d0/dble(nx)
      if(ep2.lt.hx6) ep2=hx6
      aa = 1.0d0
     
      dis = dsqrt((x-x0(1))**2+(y-x0(2))**2+(z-x0(3))**2)
      if(dis.le.epsilon) then
         aa = weight*(1.2d0-0.2d0*dis/epsilon)
      elseif(dis.le.ep2) then
         aa = weight - (weight-1.0d0)*(dis-epsilon)/(ep2-epsilon)
      endif
c
 9999 return
      end

c ---------------------------------------------------------------------
      subroutine sor123 (nx,ny,nz,a,x,id,itmax,tol,omega)
c ---------------------------------------------------------------------
      implicit real*8 (a-h,o-z)
      real*8 a(7,0:nx,0:ny,0:nz)
      real*8 x(0:nx,0:ny,0:nz)
c
      omo = 1.0d0 - omega
      nx1 = 0
      nx2 = nx
      ny1 = 0
      ny2 = ny
      nz1 = 0
      nz2 = nz
c
      if(id.eq.1) then
         nx1=1
         nx2=nx-1
      elseif(id.eq.2) then
         ny1=1
         ny2=ny-1
      else
         nz1=1
         nz2=nz-1
      endif
c
      do 100 iter = 1, itmax
c
      terr = zero
      do 1000 k = nz1,nz2
      do 1000 j = ny1,ny2
      do 1000 i = nx1,nx2
        temp = a(1,i,j,k)*x(i-1,j,k) + a(2,i,j,k)*x(i+1,j,k)
     &       + a(3,i,j,k)*x(i,j-1,k) + a(4,i,j,k)*x(i,j+1,k)
     &       + a(5,i,j,k)*x(i,j,k-1) + a(6,i,j,k)*x(i,j,k+1)
        temp = -temp/a(7,i,j,k)
        save = x(i,j,k)
        x(i,j,k) = omo*save + omega*temp
        aaa = dabs(save-x(i,j,k))
        if(aaa.gt.terr) terr=aaa
 1000 continue
      if(terr.lt.tol) then
         print'(" SOR:",i4," iterations for x(",i1,").")', iter,id
         goto 9999
      endif
 100  continue
c
 9999 return
      end

c ---------------------------------------------------------------------
      subroutine picture(nx,ny,nz,x)
c ---------------------------------------------------------------------
      implicit real*8 (a-h,o-z)
      real*8 x(0:nx,0:ny,0:nz,3)
c
      nty = ny/2
      do 1000 k = 0,nz
      do 1000 i = 0,nx
        write(1,444) x(i,nty,k,1),x(i,nty,k,3)
 1000 continue
c
      do 2000 i = 0,nx
      do 2000 k = 0,nz
        write(1,444) x(i,nty,k,1),x(i,nty,k,3)
 2000 continue
c
 444  format(2f10.5)
c
 9999 return
      end

c ---------------------------------------------------------------------
      subroutine pict3(nx,ny,nz,x)
c ---------------------------------------------------------------------
      implicit real*8 (a-h,o-z)
      real*8 x(0:nx,0:ny,0:nz,3)
c
      ntx = nx/2
      nty = ny/2
      ntz = nz/2
      do 1000 k = 0,nz
      do 1000 i = 0,ntx
        write(1,444) (x(i,0,k,nn),nn=1,3)
 1000 continue
c
      do 1200 k = 0,nz
      do 1200 j = 0,nty
        write(1,444) (x(ntx,j,k,nn),nn=1,3)
 1200 continue
c
      do 1400 k = 0,nz
      do 1400 i = ntx,nx
        write(1,444) (x(i,nty,k,nn),nn=1,3)
 1400 continue
c
      do 1600 k = 0,nz
      do 1600 j = nty,nz
        write(1,444) (x(nx,j,k,nn),nn=1,3)
 1600 continue
c
      do 1800 j = 0,nty
      do 1800 i = 0,ntx
        write(1,444) (x(i,j,nz,nn),nn=1,3)
 1800 continue
c
      do 1900 i = ntx,nx
      do 1900 j = nty,ny
        write(1,444) (x(i,j,nz,nn),nn=1,3)
 1900 continue
c
c
      do 2000 i = 0,ntx
      do 2000 k = 0,nz
        write(2,444) (x(i,0,k,nn),nn=1,3)
 2000 continue
c
      do 2200 j = 0,nty
      do 2200 k = 0,nz
        write(2,444) (x(ntx,j,k,nn),nn=1,3)
 2200 continue
c
      do 2400 i = ntx,nx
      do 2400 k = 0,nz
        write(2,444) (x(i,nty,k,nn),nn=1,3)
 2400 continue
c
      do 2600 j = nty,nz
      do 2600 k = 0,nz
        write(2,444) (x(nx,j,k,nn),nn=1,3)
 2600 continue
c
      do 2800 i = 0,ntx
      do 2800 j = 0,ny
        write(2,444) (x(i,j,nz,nn),nn=1,3)
 2800 continue
c
      do 2900 j = nty,ny
      do 2900 i = 0,nx
        write(2,444) (x(i,j,nz,nn),nn=1,3)
 2900 continue
c
 444  format(3f10.5)
c
 9999 return
      end

